//
//   13. 
// tree.h
//
#pragma once

//   :
//     tree::datatype -   ;
//     data -    ;
//     left -    ;
//     right -    .
struct tree
{
	typedef int datatype;
	datatype data;
	tree *left;
	tree *right;
};

//   .
//    .
//  :
//     count -   .
//      .
tree *get_tree(const size_t count);

//         .
//  :
//     root -    ;
//     x -  .
void insert(tree *&root, tree::datatype x);

//   . :  -  -   
//  :
//     root -     .
// root == nullptr    .
void delete_tree(tree *&root);

//          . :  -  - 
//  :
//     root -     .
void print_tree(const tree *root, size_t space = 0);

//      .  :  -  -   
//  :
//     root -     .
size_t leaves_count(const tree *root); 
